package io.zipcoder;

public class MonkeyTypewriter {
    public static void main(String[] args) {
        String introduction = "It was the best of times,\n" +
                "it was the blurst of times,\n" +
                "it was the age of wisdom,\n" +
                "it was the age of foolishness,\n" +
                "it was the epoch of belief,\n" +
                "it was the epoch of incredulity,\n" +
                "it was the season of Light,\n" +
                "it was the season of Darkness,\n" +
                "it was the spring of hope,\n" +
                "it was the winter of despair,\n" +
                "we had everything before us,\n" +
                "we had nothing before us,\n" +
                "we were all going direct to Heaven,\n" +
                "we were all going direct the other way--\n" +
                "in short, the period was so far like the present period, that some of\n" +
                "its noisiest authorities insisted on its being received, for good or for\n" +
                "evil, in the superlative degree of comparison only.";

        // Do all of the Monkey / Thread building here
        // For each Copier(one safe and one unsafe), create and start 5 monkeys copying the introduction to
        // A Tale Of Two Cities.


        // This wait is here because main is still a thread and we want the main method to print the finished copies
        // after enough time has passed.


        UnsafeCopier u = new UnsafeCopier(introduction);
        Thread monk1 = new Thread(u);
        Thread monk2 = new Thread(u);
        Thread monk3 = new Thread(u);
        Thread monk4 = new Thread(u);
        Thread monk5 = new Thread(u);
        monk1.start();
        monk2.start();
        monk3.start();
        monk4.start();
        monk5.start();



        SafeCopier s = new SafeCopier(introduction);
        Thread monk6 = new Thread(s);
        Thread monk7 = new Thread(s);
        Thread monk8 = new Thread(s);
        Thread monk9 = new Thread(s);
        Thread monk0 = new Thread(s);
        monk6.start();
        monk7.start();
        monk8.start();
        monk9.start();
        monk0.start();



        try {
            Thread.sleep(1000);
        } catch(InterruptedException e) {
            System.out.println("MAIN INTERRUPTED");
        }



        // Print out the copied versions here.
        System.out.println(u.copied);
        System.out.println("===================\n" + "===================");
        System.out.println(s.copied);
    }
}